instruction_template: |-
  {%- set ns = namespace(found=false) -%}
  {%- for message in messages -%}
      {%- if message['role'] == 'system' -%}
          {%- set ns.found = true -%}
      {%- endif -%}
  {%- endfor -%}
  {%- if not ns.found -%}
      {{- '' + '' + '' -}}
  {%- endif %}
  {%- for message in messages %}
      {%- if message['role'] == 'system' -%}
          {{- '' + message['content'] + '' -}}
      {%- else -%}
          {%- if message['role'] == 'user' -%}
              {{-'' + message['content'] + ' '-}}
          {%- else -%}
              {{-'[START_REF]' + message['content'] + '\n\n' -}}
          {%- endif -%}
      {%- endif -%}
  {%- endfor -%}
  {%- if add_generation_prompt -%}
      {{-'[START_REF]'-}}
  {%- endif -%}

